package org.jamon.node;

import org.jamon.api.Location;
public class ArgNode extends AbstractNode
{
  public ArgNode(Location p_location, ArgTypeNode p_type, ArgNameNode p_name)
  {
    super(p_location);
    if ((m_type = p_type) == null)
      { throw new NullPointerException(); }
    if ((m_name = p_name) == null)
      { throw new NullPointerException(); }
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseArgNode(this);
  }

  private final ArgTypeNode m_type;
  public ArgTypeNode getType() { return m_type; }

  private final ArgNameNode m_name;
  public ArgNameNode getName() { return m_name; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_type.equals(((ArgNode) p_obj).m_type)
      && m_name.equals(((ArgNode) p_obj).m_name)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_type.hashCode()
      ^ m_name.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addProperty(p_buffer, "type", m_type);
    addProperty(p_buffer, "name", m_name);
  }

}
