package org.jamon.node;

import org.jamon.api.Location;
public class ArgTypeNode extends AbstractNode
{
  public ArgTypeNode(Location p_location, String p_type)
  {
    super(p_location);
    if ((m_type = p_type) == null)
      { throw new NullPointerException(); }
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseArgTypeNode(this);
  }

  private final String m_type;
  public String getType() { return m_type; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_type.equals(((ArgTypeNode) p_obj).m_type)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_type.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addProperty(p_buffer, "type", m_type);
  }

}
