package org.jamon.node;

import org.jamon.api.Location;
public class ForNode extends AbstractBodyNode
{
  public ForNode(Location p_location, String p_loopSpecifier)
  {
    super(p_location);
    if ((m_loopSpecifier = p_loopSpecifier) == null)
      { throw new NullPointerException(); }
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseForNode(this);
  }

  private final String m_loopSpecifier;
  public String getLoopSpecifier() { return m_loopSpecifier; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_loopSpecifier.equals(((ForNode) p_obj).m_loopSpecifier)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_loopSpecifier.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addProperty(p_buffer, "loopSpecifier", m_loopSpecifier);
  }

}
