package org.jamon.node;

import org.jamon.api.Location;
public class FragmentArgsNode extends AbstractArgsNode
{
  public FragmentArgsNode(Location p_location, String p_fragmentName)
  {
    super(p_location);
    if ((m_fragmentName = p_fragmentName) == null)
      { throw new NullPointerException(); }
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseFragmentArgsNode(this);
  }

  private final String m_fragmentName;
  public String getFragmentName() { return m_fragmentName; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_fragmentName.equals(((FragmentArgsNode) p_obj).m_fragmentName)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_fragmentName.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addProperty(p_buffer, "fragmentName", m_fragmentName);
  }

}
